<?php
/***************************************************************
*  Copyright notice
*
*  (c) 1999-2006 Kasper Skaarhoj (kasperYYYY@typo3.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Contains TYPO3 Core Form generator - AKA "TCEforms"
 *
 * $Id: class.t3lib_tceforms.php 2153 2007-02-26 13:39:06Z liels_bugs $
 * Revised for TYPO3 3.6 August/2003 by Kasper Skaarhoj
 * XHTML compliant
 *
 * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
 */
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *  196: class t3lib_TCEforms
 *  302:     function t3lib_TCEforms()
 *  338:     function initDefaultBEmode()
 *
 *              SECTION: Rendering the forms, fields etc
 *  385:     function getSoloField($table,$row,$theFieldToReturn)
 *  424:     function getMainFields($table,$row,$depth=0)
 *  618:     function getListedFields($table,$row,$list)
 *  660:     function getPaletteFields($table,$row,$palette,$header='',$itemList='',$collapsedHeader='')
 *  737:     function getSingleField($table,$field,$row,$altName='',$palette=0,$extra='',$pal=0)
 *  900:     function getSingleField_SW($table,$field,$row,&$PA)
 *
 *              SECTION: Rendering of each TCEform field type
 *  976:     function getSingleField_typeInput($table,$field,$row,&$PA)
 * 1057:     function getSingleField_typeText($table,$field,$row,&$PA)
 * 1178:     function getSingleField_typeCheck($table,$field,$row,&$PA)
 * 1244:     function getSingleField_typeRadio($table,$field,$row,&$PA)
 * 1279:     function getSingleField_typeSelect($table,$field,$row,&$PA)
 * 1359:     function getSingleField_typeSelect_single($table,$field,$row,&$PA,$config,$selItems,$nMV_label)
 * 1490:     function getSingleField_typeSelect_checkbox($table,$field,$row,&$PA,$config,$selItems,$nMV_label)
 * 1609:     function getSingleField_typeSelect_singlebox($table,$field,$row,&$PA,$config,$selItems,$nMV_label)
 * 1719:     function getSingleField_typeSelect_multiple($table,$field,$row,&$PA,$config,$selItems,$nMV_label)
 * 1823:     function getSingleField_typeGroup($table,$field,$row,&$PA)
 * 1992:     function getSingleField_typeNone($table,$field,$row,&$PA)
 * 2008:     function getSingleField_typeNone_render($config,$itemValue)
 * 2070:     function getSingleField_typeFlex($table,$field,$row,&$PA)
 * 2205:     function getSingleField_typeFlex_langMenu($languages,$elName,$selectedLanguage,$multi=1)
 * 2224:     function getSingleField_typeFlex_sheetMenu($sArr,$elName,$sheetKey)
 * 2259:     function getSingleField_typeFlex_draw($dataStruct,$editData,$cmdData,$table,$field,$row,&$PA,$formPrefix='',$level=0,$tRows=array())
 * 2452:     function getSingleField_typeUnknown($table,$field,$row,&$PA)
 * 2467:     function getSingleField_typeUser($table,$field,$row,&$PA)
 *
 *              SECTION: Field content processing
 * 2496:     function formatValue ($config, $itemValue)
 *
 *              SECTION: "Configuration" fetching/processing functions
 * 2588:     function getRTypeNum($table,$row)
 * 2614:     function rearrange($fields)
 * 2640:     function getExcludeElements($table,$row,$typeNum)
 * 2688:     function getFieldsToAdd($table,$row,$typeNum)
 * 2713:     function mergeFieldsWithAddedFields($fields,$fieldsToAdd)
 * 2745:     function setTSconfig($table,$row,$field='')
 * 2767:     function getSpecConfForField($table,$row,$field)
 * 2788:     function getSpecConfFromString($extraString, $defaultExtras)
 *
 *              SECTION: Display of localized content etc.
 * 2816:     function registerDefaultLanguageData($table,$rec)
 * 2848:     function getLanguageOverlayRawValue($table, $row, $field, $fieldConf)
 * 2876:     function renderDefaultLanguageContent($table,$field,$row,$item)
 * 2899:     function renderDefaultLanguageDiff($table,$field,$row,$item)
 *
 *              SECTION: Form element helper functions
 * 2955:     function dbFileIcons($fName,$mode,$allowed,$itemArray,$selector='',$params=array(),$onFocus='')
 * 3108:     function getClipboardElements($allowed,$mode)
 * 3157:     function getClickMenu($str,$table,$uid='')
 * 3178:     function renderWizards($itemKinds,$wizConf,$table,$row,$field,&$PA,$itemName,$specConf,$RTE=0)
 * 3382:     function getIcon($icon)
 * 3409:     function optionTagStyle($iconString)
 * 3425:     function extractValuesOnlyFromValueLabelList($itemFormElValue)
 * 3447:     function wrapOpenPalette($header,$table,$row,$palette,$retFunc=0)
 * 3471:     function checkBoxParams($itemName,$thisValue,$c,$iCount,$addFunc='')
 * 3485:     function elName($itemName)
 * 3496:     function noTitle($str,$wrapParts=array())
 * 3505:     function blur()
 * 3514:     function thisReturnUrl()
 * 3527:     function getSingleHiddenField($table,$field,$row)
 * 3549:     function formWidth($size=48,$textarea=0)
 * 3576:     function formWidthText($size=48,$wrap='')
 * 3592:     function formElStyle($type)
 * 3603:     function formElClass($type)
 * 3614:     function formElStyleClassValue($type, $class=FALSE)
 * 3638:     function insertDefStyle($type)
 * 3657:     function getDynTabMenu($parts, $idString)
 *
 *              SECTION: Item-array manipulation functions (check/select/radio)
 * 3696:     function initItemArray($fieldValue)
 * 3714:     function addItems($items,$iArray)
 * 3736:     function procItems($items,$iArray,$config,$table,$row,$field)
 * 3760:     function addSelectOptionsToItemArray($items,$fieldValue,$TSconfig,$field)
 * 3980:     function addSelectOptionsToItemArray_makeModuleData($value)
 * 4002:     function foreignTable($items,$fieldValue,$TSconfig,$field,$pFFlag=0)
 *
 *              SECTION: Template functions
 * 4083:     function setNewBEDesign()
 * 4138:     function intoTemplate($inArr,$altTemplate='')
 * 4162:     function addUserTemplateMarkers($marker,$table,$field,$row,&$PA)
 * 4173:     function wrapLabels($str)
 * 4186:     function wrapTotal($c,$rec,$table)
 * 4199:     function replaceTableWrap($arr,$rec,$table)
 * 4236:     function wrapBorder(&$out_array,&$out_pointer)
 * 4258:     function rplColorScheme($inTemplate)
 * 4278:     function getDivider()
 * 4288:     function printPalette($palArr)
 * 4339:     function helpTextIcon($table,$field,$force=0)
 * 4359:     function helpText($table,$field)
 * 4380:     function setColorScheme($scheme)
 * 4404:     function resetSchemes()
 * 4415:     function storeSchemes()
 * 4427:     function restoreSchemes()
 *
 *              SECTION: JavaScript related functions
 * 4457:     function JStop()
 * 4508:     function JSbottom($formname='forms[0]')
 * 4835:     function dbFileCon($formObj='document.forms[0]')
 * 5053:     function printNeededJSFunctions()
 * 5080:     function printNeededJSFunctions_top()
 *
 *              SECTION: Various helper functions
 * 5128:     function getDefaultRecord($table,$pid=0)
 * 5167:     function getRecordPath($table,$rec)
 * 5181:     function readPerms()
 * 5195:     function sL($str)
 * 5208:     function getLL($str)
 * 5229:     function isPalettesCollapsed($table,$palette)
 * 5245:     function isDisplayCondition($displayCond,$row,$ffValueKey='')
 * 5349:     function getTSCpid($table,$uid,$pid)
 * 5363:     function doLoadTableDescr($table)
 * 5375:     function getAvailableLanguages($onlyIsoCoded=1,$setDefault=1)
 *
 *
 * 5417: class t3lib_TCEforms_FE extends t3lib_TCEforms
 * 5425:     function wrapLabels($str)
 * 5435:     function printPalette($palArr)
 * 5460:     function setFancyDesign()
 *
 * TOTAL FUNCTIONS: 100
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */
 
require_once(PATH_t3lib.'class.t3lib_tceforms.php');

/**
 * 'TCEforms' - Class for creating the backend editing forms.
 *
 * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
 * @coauthor	Rene Fritz <r.fritz@colorcube.de>
 * @package TYPO3
 * @subpackage t3lib
 */
class ux_t3lib_TCEforms	extends t3lib_TCEforms{

	
/**
	 * Generation of TCEform elements of the type "group"
	 * This will render a selectorbox into which elements from either the file system or database can be inserted. Relations.
	 *
	 * @param	string		The table name of the record
	 * @param	string		The field name which this element is supposed to edit
	 * @param	array		The record data array where the value(s) for the field can be found
	 * @param	array		An array with additional configuration options.
	 * @return	string		The HTML code for the TCEform field
	 */
	function getSingleField_typeGroup($table,$field,$row,&$PA)	{
			// Init:
		//	debug($row);

		$config = $PA['fieldConf']['config'];
		$internal_type = $config['internal_type'];
		$show_thumbs = $config['show_thumbs'];
		$size = intval($config['size']);
		$maxitems = t3lib_div::intInRange($config['maxitems'],0);
		if (!$maxitems)	$maxitems=100000;
		$minitems = t3lib_div::intInRange($config['minitems'],0);
		$allowed = $config['allowed'];
		$disallowed = $config['disallowed'];

		$disabled = '';
		if($this->renderReadonly || $config['readOnly'])  {
			$disabled = ' disabled="disabled"';
		}

		$item.= '<input type="hidden" name="'.$PA['itemFormElName'].'_mul" value="'.($config['multiple']?1:0).'"'.$disabled.' />';
		$this->requiredElements[$PA['itemFormElName']] = array($minitems,$maxitems,'imgName'=>$table.'_'.$row['uid'].'_'.$field);
		$info='';

			// "Extra" configuration; Returns configuration for the field based on settings found in the "types" fieldlist. See http://typo3.org/documentation/document-library/doc_core_api/Wizards_Configuratio/.
		$specConf = $this->getSpecConfFromString($PA['extra'], $PA['fieldConf']['defaultExtras']);

		// Acting according to either "file" or "db" type:
		switch((string)$config['internal_type'])	{
			case 'file':	// If the element is of the internal type "file":

					// Creating string showing allowed types:
				$tempFT = t3lib_div::trimExplode(',',$allowed,1);
				if (!count($tempFT))	{$info.='*';}
				foreach($tempFT as $ext)	{
					if ($ext)	{
						$info.=strtoupper($ext).' ';
					}
				}
					// Creating string, showing disallowed types:
				$tempFT_dis = t3lib_div::trimExplode(',',$disallowed,1);
				if (count($tempFT_dis))	{$info.='<br />';}
				foreach($tempFT_dis as $ext)	{
					if ($ext)	{
						$info.='-'.strtoupper($ext).' ';
					}
				}

					// Making the array of file items:
				$itemArray = t3lib_div::trimExplode(',',$PA['itemFormElValue'],1);

					// Showing thumbnails:
				$thumbsnail = '';
				if ($show_thumbs)	{
					$imgs = array();
					foreach($itemArray as $imgRead)	{
						$imgP = explode('|',$imgRead);
						$imgPath = rawurldecode($imgP[0]);

						$rowCopy = array();
						$rowCopy[$field] = $imgPath;

							// Icon + clickmenu:
						$absFilePath = t3lib_div::getFileAbsFileName($config['uploadfolder'].'/'.$imgPath);

						$fI = pathinfo($imgPath);
						$fileIcon = t3lib_BEfunc::getFileIcon(strtolower($fI['extension']));
						$fileIcon = '<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/fileicons/'.$fileIcon,'width="18" height="16"').' class="absmiddle" title="'.htmlspecialchars($fI['basename'].($absFilePath && @is_file($absFilePath) ? ' ('.t3lib_div::formatSize(filesize($absFilePath)).'bytes)' : ' - FILE NOT FOUND!')).'" alt="" />';

						$imgs[] = '<span class="nobr">'.t3lib_BEfunc::thumbCode($rowCopy,$table,$field,$this->backPath,'thumbs.php',$config['uploadfolder'],0,' align="middle"').
									($absFilePath ? $this->getClickMenu($fileIcon, $absFilePath) : $fileIcon).
									$imgPath.
									'</span>';
					}
					$thumbsnail = implode('<br />',$imgs);
				}

					// Creating the element:
				$params = array(
					'size' => $size,
					'dontShowMoveIcons' => ($maxitems<=1),
					'autoSizeMax' => t3lib_div::intInRange($config['autoSizeMax'],0),
					'maxitems' => $maxitems,
					'style' => isset($config['selectedListStyle']) ? ' style="'.htmlspecialchars($config['selectedListStyle']).'"' : ' style="'.$this->defaultMultipleSelectorStyle.'"',
					'info' => $info,
					'thumbnails' => $thumbsnail,
					'readOnly' => $disabled
				);
				$item.= $this->dbFileIcons($PA['itemFormElName'],'file',implode(',',$tempFT),$itemArray,'',$params,$PA['onFocus']);

				if(!$disabled) {
						// Adding the upload field:
					if ($this->edit_docModuleUpload)	$item.='<input type="file" name="'.$PA['itemFormElName_file'].'"'.$this->formWidth().' size="60" />';
				}
			break;
			case 'db':	// If the element is of the internal type "db":

					// Creating string showing allowed types:
				$tempFT = t3lib_div::trimExplode(',',$allowed,1);
				if (!strcmp(trim($tempFT[0]),'*'))	{
					$info.='<span class="nobr">&nbsp;&nbsp;&nbsp;&nbsp;'.
							htmlspecialchars($this->getLL('l_allTables')).
							'</span><br />';
				} else {
					while(list(,$theT)=each($tempFT))	{
						if ($theT)	{
							$info.='<span class="nobr">&nbsp;&nbsp;&nbsp;&nbsp;'.
									t3lib_iconWorks::getIconImage($theT,array(),$this->backPath,'align="top"').
									htmlspecialchars($this->sL($GLOBALS['TCA'][$theT]['ctrl']['title'])).
									'</span><br />';
						}
					}
				}

				$perms_clause = $GLOBALS['BE_USER']->getPagePermsClause(1);
				$itemArray = array();
				$imgs = array();

					// Thumbnails:
				$temp_itemArray = t3lib_div::trimExplode(',',$PA['itemFormElValue'],1);
//				debug($PA['itemFormElValue']);
				foreach($temp_itemArray as $dbRead)	{
					$recordParts = explode('|',$dbRead);
					list($this_table,$this_uid) = t3lib_BEfunc::splitTable_Uid($recordParts[0]);
					$itemArray[] = array('table'=>$this_table, 'id'=>$this_uid);
					if (!$disabled && $show_thumbs)	{
						$rr = t3lib_BEfunc::getRecordWSOL($this_table,$this_uid);
						$imgs[] = '<span class="nobr">'.
								$this->getClickMenu(t3lib_iconWorks::getIconImage($this_table,$rr,$this->backPath,'align="top" title="'.htmlspecialchars(t3lib_BEfunc::getRecordPath($rr['pid'],$perms_clause,15)).' [UID: '.$rr['uid'].']"'),$this_table, $this_uid).
								'&nbsp;'.
								t3lib_BEfunc::getRecordTitle($this_table,$rr,TRUE).' <span class="typo3-dimmed"><em>['.$rr['uid'].']</em></span>'.
								'</span>';
					}
				}
				$thumbsnail='';
				if (!$disabled && $show_thumbs)	{
					$thumbsnail = implode('<br />',$imgs);
				}
        
					// Creating the element:
				$params = array(
					'size' => $size,
					'dontShowMoveIcons' => ($maxitems<=1),
					'autoSizeMax' => t3lib_div::intInRange($config['autoSizeMax'],0),
					'maxitems' => $maxitems,
					'style' => isset($config['selectedListStyle']) ? ' style="'.htmlspecialchars($config['selectedListStyle']).'"' : ' style="'.$this->defaultMultipleSelectorStyle.'"',
					'info' => $info,
					'thumbnails' => $thumbsnail,
					'readOnly' => $disabled,
					//stoefln
					'alert' => $PA['fieldChangeFunc']['alert']  
				);
				
				$item.= $this->dbFileIcons($PA['itemFormElName'],'db',implode(',',$tempFT),$itemArray,'',$params,$PA['onFocus'],$table,$field,$row['uid']);

			break;
		}

			// Wizards:
		$altItem = '<input type="hidden" name="'.$PA['itemFormElName'].'" value="'.htmlspecialchars($PA['itemFormElValue']).'" />';
		if (!$disabled) {
			$item = $this->renderWizards(array($item,$altItem),$config['wizards'],$table,$row,$field,$PA,$PA['itemFormElName'],$specConf);
		}

		return $item;
	}




	/************************************************************
	 *
	 * Form element helper functions
	 *
	 ************************************************************/

	/**
	 * Prints the selector box form-field for the db/file/select elements (multiple)
	 *
	 * @param	string		Form element name
	 * @param	string		Mode "db", "file" (internal_type for the "group" type) OR blank (then for the "select" type)
	 * @param	string		Commalist of "allowed"
	 * @param	array		The array of items. For "select" and "group"/"file" this is just a set of value. For "db" its an array of arrays with table/uid pairs.
	 * @param	string		Alternative selector box.
	 * @param	array		An array of additional parameters, eg: "size", "info", "headers" (array with "selector" and "items"), "noBrowser", "thumbnails"
	 * @param	string		On focus attribute string
	 * @param	string		$table: (optional) Table name processing for
	 * @param	string		$field: (optional) Field of table name processing for
	 * @param	string		$uid:	(optional) uid of table record processing for
	 * @return	string		The form fields for the selection.
	 */
	function dbFileIcons($fName,$mode,$allowed,$itemArray,$selector='',$params=array(),$onFocus='',$table='',$field='',$uid='')	{


		$disabled = '';
		if($this->renderReadonly || $params['readOnly'])  {
			$disabled = ' disabled="disabled"';
		}

			// Sets a flag which means some JavaScript is included on the page to support this element.
		$this->printNeededJS['dbFileIcons']=1;

			// INIT
		$uidList=array();
		$opt=array();
		$itemArrayC=0;

			// Creating <option> elements:
		if (is_array($itemArray))	{
			$itemArrayC=count($itemArray);
			reset($itemArray);
			switch($mode)	{
				case 'db':
					while(list(,$pp)=each($itemArray))	{
						$pRec = t3lib_BEfunc::getRecordWSOL($pp['table'],$pp['id']);
						if (is_array($pRec))	{
							$pTitle = t3lib_BEfunc::getRecordTitle($pp['table'], $pRec, FALSE, TRUE);
							$pUid = $pp['table'].'_'.$pp['id'];
							$uidList[]=$pUid;
							$opt[]='<option value="'.htmlspecialchars($pUid).'">'.htmlspecialchars($pTitle).'</option>';
						}
					}
				break;
				case 'file':
					while(list(,$pp)=each($itemArray))	{
						$pParts = explode('|',$pp);
						$uidList[]=$pUid=$pTitle = $pParts[0];
						$opt[]='<option value="'.htmlspecialchars(rawurldecode($pParts[0])).'">'.htmlspecialchars(rawurldecode($pParts[0])).'</option>';
					}
				break;
				default:
					while(list(,$pp)=each($itemArray))	{
						$pParts = explode('|',$pp, 2);
						$uidList[]=$pUid=$pParts[0];
						$pTitle = $pParts[1];
						$opt[]='<option value="'.htmlspecialchars(rawurldecode($pUid)).'">'.htmlspecialchars(rawurldecode($pTitle)).'</option>';
					}
				break;
			}
		}

			// Create selector box of the options
		$sSize = $params['autoSizeMax'] ? t3lib_div::intInRange($itemArrayC+1,t3lib_div::intInRange($params['size'],1),$params['autoSizeMax']) : $params['size'];
		if (!$selector)	{
			$selector = '<select size="'.$sSize.'"'.$this->insertDefStyle('group').' multiple="multiple" name="'.$fName.'_list" '.$onFocus.$params['style'].$disabled.'>'.implode('',$opt).'</select>';
		}


		$icons = array(
			'L' => array(),
			'R' => array(),
		);
		if (!$params['readOnly']) {
			if (!$params['noBrowser'])	{
					// check against inline uniqueness
				$inlineParent = $this->inline->getStructureLevel(-1);
				if(is_array($inlineParent) && $inlineParent['uid']) {
					if ($inlineParent['config']['foreign_table'] == $table && $inlineParent['config']['foreign_unique'] == $field) {
						$objectPrefix = $this->inline->inlineNames['object'].'['.$table.']';
						$aOnClickInline = $objectPrefix.'|inline.checkUniqueElement|inline.setUniqueElement';
						$rOnClickInline = 'inline.revertUnique(\''.$objectPrefix.'\',null,\''.$uid.'\');';
					}
				}
				
				
        //stoefln ++
				$refresh = $params['alert']? "1" : "0";
				$aOnClick='setFormValueOpenBrowser(\''.$mode.'\',\''.($fName.'|||'.$allowed.'|'.$aOnClickInline.'||||'.$refresh).'\'); return false;';
				//stoefln end
				//stoefln --
				//$aOnClick='setFormValueOpenBrowser(\''.$mode.'\',\''.($fName.'|||'.$allowed.'|'.$aOnClickInline).'\'); return false;';
				
        $icons['R'][]='<a href="#" onclick="'.htmlspecialchars($aOnClick).'">'.
						'<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/insert3.gif','width="14" height="14"').' border="0" '.t3lib_BEfunc::titleAltAttrib($this->getLL('l_browse_'.($mode=='file'?'file':'db'))).' />'.
						'</a>';
			}
			if (!$params['dontShowMoveIcons'])	{
				//stoefln edit: added '.$params['alert'].'  -> page has to be realoaded in case of changes (order)
				if ($sSize>=5)	{
				  
					$icons['L'][]='<a href="#" onclick="setFormValueManipulate(\''.$fName.'\',\'Top\');'.$params['alert'].'return false;">'.
							'<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/group_totop.gif','width="14" height="14"').' border="0" '.t3lib_BEfunc::titleAltAttrib($this->getLL('l_move_to_top')).' />'.
							'</a>';
				}
				$icons['L'][]='<a href="#" onclick="setFormValueManipulate(\''.$fName.'\',\'Up\');'.$params['alert'].'return false;">'.
						'<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/up.gif','width="14" height="14"').' border="0" '.t3lib_BEfunc::titleAltAttrib($this->getLL('l_move_up')).' />'.
						'</a>';
				$icons['L'][]='<a href="#" onclick="setFormValueManipulate(\''.$fName.'\',\'Down\');'.$params['alert'].'return false;">'.
						'<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/down.gif','width="14" height="14"').' border="0" '.t3lib_BEfunc::titleAltAttrib($this->getLL('l_move_down')).' />'.
						'</a>';
				if ($sSize>=5)	{
					$icons['L'][]='<a href="#" onclick="setFormValueManipulate(\''.$fName.'\',\'Bottom\');'.$params['alert'].'return false;">'.
							'<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/group_tobottom.gif','width="14" height="14"').' border="0" '.t3lib_BEfunc::titleAltAttrib($this->getLL('l_move_to_bottom')).' />'.
							'</a>';
				}
				//stoefln edit end
			}

			$clipElements = $this->getClipboardElements($allowed,$mode);
			if (count($clipElements))	{
				$aOnClick = '';
	#			$counter = 0;
				foreach($clipElements as $elValue)	{
					if ($mode=='file')	{
						$itemTitle = 'unescape(\''.rawurlencode(basename($elValue)).'\')';
					} else {	// 'db' mode assumed
						list($itemTable,$itemUid) = explode('|', $elValue);
						$itemTitle = $GLOBALS['LANG']->JScharCode(t3lib_BEfunc::getRecordTitle($itemTable, t3lib_BEfunc::getRecordWSOL($itemTable,$itemUid)));
						$elValue = $itemTable.'_'.$itemUid;
					}
					$aOnClick.= 'setFormValueFromBrowseWin(\''.$fName.'\',unescape(\''.rawurlencode(str_replace('%20',' ',$elValue)).'\'),'.$itemTitle.');';

	#				$counter++;
	#				if ($params['maxitems'] && $counter >= $params['maxitems'])	{	break;	}	// Makes sure that no more than the max items are inserted... for convenience.
				}
				$aOnClick.= 'return false;';
				$icons['R'][]='<a href="#" onclick="'.htmlspecialchars($aOnClick).'">'.
						'<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/insert5.png','width="14" height="14"').' border="0" '.t3lib_BEfunc::titleAltAttrib(sprintf($this->getLL('l_clipInsert_'.($mode=='file'?'file':'db')),count($clipElements))).' />'.
						'</a>';
			}
			//stoefln--
			//$rOnClick = $rOnClickInline.'setFormValueManipulate(\''.$fName.'\',\'Remove\');return false';
			//stoefln++
			$rOnClick = $rOnClickInline.'setFormValueManipulate(\''.$fName.'\',\'Remove\');'.$params['alert'].'return false';
			//stoefln end
			$icons['L'][]='<a href="#" onclick="'.htmlspecialchars($rOnClick).'">'.
					'<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/group_clear.gif','width="14" height="14"').' border="0" '.t3lib_BEfunc::titleAltAttrib($this->getLL('l_remove_selected')).' />'.
					'</a>';
		}

		$str='<table border="0" cellpadding="0" cellspacing="0" width="1">
			'.($params['headers']?'
				<tr>
					<td>'.$this->wrapLabels($params['headers']['selector']).'</td>
					<td></td>
					<td></td>
					<td></td>
					<td>'.($params['thumbnails'] ? $this->wrapLabels($params['headers']['items']) : '').'</td>
				</tr>':'').
			'
			<tr>
				<td valign="top">'.
					$selector.'<br />'.
					$this->wrapLabels($params['info']).
				'</td>
				<td valign="top">'.
					implode('<br />',$icons['L']).'</td>
				<td valign="top">'.
					implode('<br />',$icons['R']).'</td>
				<td><img src="clear.gif" width="5" height="1" alt="" /></td>
				<td valign="top">'.
					$this->wrapLabels($params['thumbnails']).
				'</td>
			</tr>
		</table>';

			// Creating the hidden field which contains the actual value as a comma list.
		$str.='<input type="hidden" name="'.$fName.'" value="'.htmlspecialchars(implode(',',$uidList)).'" />';

		return $str;
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.ux_t3lib_tceforms.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.ux_t3lib_tceforms.php']);
}
?>
